C
C Calculate ferrite lattice parameter P at room temperature for alloy steel
C Data from Leslie, concentrations input as wt.%, balance iron
C Mo effect F. Wever, Zeitschrift fur Metallkunde 20 (1928) 363-370
C CALP is wt.% carbon dissolved in ferrite
C Vanadium coefficient from Hume-Rothery an Sutton (Structure of Iron+Alloys)
C Set PFE as the parameter of pure iron at room temperature
C Value of 2.8664 Ansgtroms for PFE from National Bureau of Standards (USA)
C Circ. 539, 4 3 (1955)
C H. K. D. H. Bhadeshia, 6 September 1989
C
      SUBROUTINE MAP_STEEL_FERR(C,SI,MN,NI,MO,CR,V,CALP,PFE,P)
      IMPLICIT NONE 
      DOUBLE PRECISION C,SI,MN,NI,MO,CR,V,CALP,P,PFE,ASI,AMN,
     &ANI,ACR,AMO,AV,FE,AFE,AC,M,MSI,MMN,MNI,MCR,MMO,MFE,MC,
     &MV,V1,V2,CC
C
      ASI=SI/28.0855
      AMN=MN/54.938
      ANI=NI/58.71
      ACR=CR/51.996
      AMO=MO/95.94
      AV=V/50.9415
C     AW=W/183.85
C     ACO=CO/58.9332
C
      FE=100.0-C-SI-MN-NI-MO-CR-V
      AFE=FE/55.847
      AC=C/12.011
C
      M=AC+ASI+AMN+ANI+AMO+ACR+AV+AFE
      MSI=ASI/M
      MMN=AMN/M
      MNI=ANI/M
      MCR=ACR/M
      MMO=AMO/M
C     MW=AW/M
C     MCO=ACO/M
      MFE=AFE/M
      MC=AC/M
      MV=AV/M
C
C expansion caused by carbon 
C Reference: C. S. Roberts, Trans. AIME, 197 (1953) 203
C
      V1=PFE*PFE*PFE
      V2=(PFE - 0.013D-10*CALP)*(PFE - 0.013D-10*CALP)*
     &   (PFE + 0.116D-10*CALP)
      CC=(V2-V1)/(3.0*PFE*PFE)
C
      P=PFE+CC - MSI*3.0D-12 + MMN*0.06D-10 + MNI*0.07D-10
     &  + MMO*0.31D-10 + MCR*0.05D-10 + MV*0.096D-10 
      RETURN
      END

